import type { JSX } from '../../stencil-public-runtime';
import type { CheckedPropType, DisabledPropType, FocusableElement, HideLabelPropType, HideMsgPropType, HintPropType, IndeterminatePropType, InputCheckboxAPI, InputCheckboxIconsProp, InputCheckboxStates, InputTypeOnDefault, KolFocusOptions, LabelAlignPropType, LabelWithExpertSlotPropType, MsgPropType, NamePropType, RequiredPropType, ShortKeyPropType, StencilUnknown, Stringified, SyncValueBySelectorPropType, TooltipAlignPropType } from '../../schema';
import type { InputCheckboxVariantPropType } from '../../schema/props/variant-input-checkbox';
export declare class KolInputCheckbox implements InputCheckboxAPI, FocusableElement {
    protected readonly host?: HTMLKolInputCheckboxElement;
    protected readonly ctaRef: import("../../utils/element-interaction").CtaRef<HTMLInputElement>;
    private getModelValue;
    getValue(): Promise<StencilUnknown>;
    focus(options?: KolFocusOptions): Promise<void>;
    click(): Promise<void>;
    private getFormFieldProps;
    private getFieldControlProps;
    private getInputProps;
    private getIcon;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: string;
    _checked?: boolean;
    _hideMsg?: boolean;
    _disabled?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: Stringified<InputCheckboxIconsProp>;
    _indeterminate?: boolean;
    _label: LabelWithExpertSlotPropType;
    _labelAlign?: LabelAlignPropType;
    _msg?: Stringified<MsgPropType>;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _required?: boolean;
    _shortKey?: ShortKeyPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value: StencilUnknown;
    _variant?: InputCheckboxVariantPropType;
    state: InputCheckboxStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validateAccessKey(value?: string): void;
    validateChecked(value?: CheckedPropType): void;
    validateDisabled(value?: DisabledPropType): void;
    validateHideMsg(value?: HideMsgPropType): void;
    validateHideLabel(value?: HideLabelPropType): void;
    validateHint(value?: HintPropType): void;
    validateIcons(value?: Stringified<InputCheckboxIconsProp>): void;
    validateIndeterminate(value?: IndeterminatePropType): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateLabelAlign(value?: LabelAlignPropType): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateRequired(value?: RequiredPropType): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTouched(value?: boolean): void;
    validateValue(value: StencilUnknown): void;
    validateVariant(value?: InputCheckboxVariantPropType): void;
    componentWillLoad(): void;
    private onInput;
    private onChange;
    private readonly onKeyDown;
}
